<?php  namespace OPiQuotations; require_once 'OPiQuotations/log.inc'; require_once 'OPiQuotations/OPiQuotation.inc'; class Db { public function __construct($host, $user, $password, $db_name) { \mysqli_report(MYSQLI_REPORT_OFF); $this->connect = new \mysqli($host, $user, $password, $db_name); if ( $this->connect->connect_error ) { to_log('mysqli connect error '.\mysqli_connect_errno().' : '.\mysqli_connect_error().'
'.@print_r($this->connect, true)); $this->connect = null; } elseif ( !$this->connect->set_charset('utf8') ) { to_log('mysqli::set_charset(\'utf8\') failed!
Server:'.$this->connect->server_info.'
Client:'.$this->connect->client_info.'
'.@print_r($this->connect, true)); $this->connect->close(); $this->connect = null; } } public function __destruct() { if ( !empty($this->connect) ) { $this->connect->close(); } } public function is_connected() { return !empty($this->connect); } public function escape($s) { return $this->connect->real_escape_string($s); } public function list_to_assoc($table) { $quots = array(); if (!$this->is_connected()) { to_log('Db.list_to_assoc(\''.print_r($table, true).'\') impossible because is NOT connected!'); return $quots; } $id_names = array('author' => 'nation_author_id', 'nation' => 'nation_author_id'); $id_name = (isset($id_names[$table]) ? $id_names[$table] : $table.'_id'); $is_maxim = ($table === 'nation' ? ' AND `q`.`is_maxim`=1' : ($table === 'author' || $table === 'work' ? ' AND `q`.`is_maxim`=0' : '')); $query = 'SELECT `t`.`id`, `t`.`name`, (SELECT COUNT(*) FROM `quotation` AS `q` WHERE `t`.`id`=`q`.`'.$id_name.'`'.$is_maxim.') AS `nb`
FROM `'.$table.'` AS `t`
ORDER BY `name` COLLATE utf8_unicode_ci;'; $result = $this->connect->query($query); if ( $result !== false ) { while ($row = $result->fetch_assoc()) { settype($row['id'], 'int'); settype($row['nb'], 'int'); if ($row['nb'] > 0) { $quots[$row['id']] = array($row['name'], $row['nb']); } } $result->free_result(); } else { to_log('MySQL Db.list_to_assoc
'.$query.'
failed!
Server:'.$this->connect->server_info.'
Client:'.$this->connect->client_info.'
'.@print_r($this->connect, true)); } return $quots; } public function nb($is_maxim=null) { if (!$this->is_connected()) { to_log('Db.nb(\''.print_r($is_maxim, true).'\') impossible because is NOT connected!'); return 0; } $query = 'SELECT COUNT(*) AS `nb`
FROM `quotation` AS `q`'; if ($is_maxim !== null) { $query .= '
WHERE `q`.`is_maxim`='.($is_maxim ? '1' : '0'); } $query .= ';'; $result = $this->connect->query($query); if ( $result !== false ) { $row = $result->fetch_assoc(); return (int)$row['nb']; } else { to_log('MySQL query
'.$query.'
failed!
Server:'.$this->connect->server_info.'
Client:'.$this->connect->client_info.'
'.@print_r($this->connect, true)); return 0; } } public function query_insert($query) { if (!$this->is_connected()) { to_log('Db.query_insert(\''.print_r($query, true).'\') impossible because is NOT connected!'); return $quots; } $r = $this->connect->query($query); if (!$r) { to_log('MySQL Db.query_insert
'.$query.'
failed!
Server:'.$this->db->connect->server_info.'
Client:'.$this->db->connect->client_info.'
'.@print_r($this->db->connect, true)); } return $r; } public function query_quotations($where, $order='') { $quots = array(); if (!$this->is_connected()) { to_log('Db.query_quotations(\''.print_r($where, true).'\', \''.print_r($order, true).'\') impossible because is NOT connected!'); return $quots; } $query = array('SELECT `id`, `text`, `translation`, `is_maxim`, `is_marked`, `subject`, `nation`, `author`, `work`', 'FROM `vw_quotation`'); $where = (string)$where; if ($where !== '') { $query[] = $where; } $order = (string)$order; if ($order !== '') { $query[] = $order; } $query = implode('
', $query).';'; $result = $this->connect->query($query); if ( $result !== false ) { while ($row = $result->fetch_assoc()) { settype($row['id'], 'int'); settype($row['is_maxim'], 'bool'); settype($row['is_marked'], 'bool'); $quots[] = new OPiQuotation($row['id'], $row['text'], $row['is_maxim'], $row['is_marked'], $row['translation'], $row['subject'], ($row['is_maxim'] ? $row['nation'] : $row['author']), $row['work']); } $result->free_result(); } else { to_log('MySQL Db.query_quotations
'.$query.'
failed!
Server:'.$this->connect->server_info.'
Client:'.$this->connect->client_info.'
'.@print_r($this->connect, true)); } return $quots; } protected $connect; } return true; ?>