<?php  require_once 'OPiQuotations/log.inc'; ini_set('display_errors', 'stderr'); ini_set('display_startup_errors', 0); ini_set('html_errors', 0); error_reporting(-1); assert_options(ASSERT_ACTIVE, false); assert_options(ASSERT_WARNING, false); assert_options(ASSERT_BAIL, false); set_error_handler('\OPiQuotations\error_handler'); mb_internal_encoding('UTF-8'); mb_regex_encoding('UTF-8'); mb_http_output('UTF-8'); mb_detect_order('UTF-8'); require_once 'OPiQuotations/OPiQuotations.inc'; $opiquotations = new OPiQuotations\OPiQuotations(); $lists = array('author' => $opiquotations->list_authors(), 'nation' => $opiquotations->list_nations(), 'subject' => $opiquotations->list_subjects(), 'work' => $opiquotations->list_works()); $LABELS = array('ids' => 'Numéro(s)', 'subject' => 'Sujet', 'text' => 'Texte', 'translation' => 'Traduction', 'author' => 'Auteur', 'work' => '&OElig;uvre', 'nation' => 'Nation'); $ALL_KEYS = array_merge(array_keys($LABELS), ['id', 'all_marked', 'all']); $params = array(); foreach ($_GET as $key=>$label) { if (in_array($key, $ALL_KEYS) && !isset($params[$key])) { $params[$key] = $_GET[$key]; } } unset($key); unset($ALL_KEYS); foreach (array('all', 'all_marked') as $key) { if (isset($_params[$key])) { $params[$key] = null; } } unset($key); foreach ($params as $key=>$value) { if ($value !== null) { $params[$key] = preg_replace('/\.\.\./', '…', preg_replace('/\'/', '’', trim($value))); } } unset($key); unset($value); $param_key = null; $param_value = null; if (!empty($params)) { reset($params); $param_key = key($params); $param_value = (in_array($param_key, ['all_marked', 'all']) ? null : $params[$param_key]); } $search = null; $param_id = null; if ($param_key === 'id') { $param_id = (int)$param_value; $quots = $opiquotations->quotations_by_ids([$param_id]); $header = null; $params['ids'] = (string)$param_id; } else if ($param_key === 'ids') { $ids = preg_replace('/(^[^0-9]+|[^0-9]+$)/', '', $param_value); $ids = mb_split('[^\-0-9]+', $ids); for ($i = 0; $i < count($ids); $i++) { $id = &$ids[$i]; $id = preg_replace('/(^[^0-9]+|[^0-9]+$)/', '', $id); if ($id === '') { $id = '0'; } $a = mb_split('-', $id); $id = (int)$a[0]; $count_a = count($a); if ($count_a > 1) { for ($j = (int)$a[0] + 1; $j <= (int)$a[$count_a - 1]; $j++) { $ids[] = $j; } } } unset($a); unset($i); unset($j); unset($count_a); unset($id); $ids = array_unique($ids, SORT_NUMERIC); sort($ids); if ((count($ids) > 0) && ($ids[0] === 0)) { array_shift($ids); } $a = array(); $first = null; if (count($ids) > 0) { $first = $ids[0]; for ($i = 0; $i < count($ids) - 1; $i++) { if ($ids[$i + 1] !== $ids[$i] + 1) { $a[] = ($first === $ids[$i] ? (string)$first : "$first-$ids[$i]"); $first = $ids[$i + 1]; } } $a[] = ($first === $ids[$i] ? (string)$first : "$first-$ids[$i]"); unset($first); unset($i); } $quots = $opiquotations->quotations_by_ids($ids); $header = '<strong>Numéro(s)</strong> '.implode(', ', $a).'&thinsp;: '.count($quots).' résultat(s).'; $param_value = implode(',', $a); unset($a); } else if ($param_key === 'subject') { $quots = $opiquotations->quotations_by_subject($param_value); $header = '<strong>Sujet</strong> &quot;'.htmlspecialchars($param_value).'&quot;&thinsp;: '.count($quots).' résultat(s).'; $search = $param_value; } else if ($param_key === 'text') { $quots = $opiquotations->quotations_by_text($param_value); $header = '<strong>Texte</strong> &quot;'.htmlspecialchars($param_value).'&quot;&thinsp;: '.count($quots).' résultat(s).'; $search = $param_value; } else if ($param_key === 'author') { $quots = $opiquotations->quotations_by_author($param_value); $header = '<strong>Auteur</strong> &quot;'.htmlspecialchars($param_value).'&quot;&thinsp;: '.count($quots).' résultat(s).'; $search = $param_value; } else if ($param_key === 'work') { $quots = $opiquotations->quotations_by_work($param_value); $header = '<strong>&OElig;uvre</strong> &quot;'.htmlspecialchars($param_value).'&quot;&thinsp;: '.count($quots).' résultat(s).'; $search = $param_value; } else if ($param_key === 'nation') { $quots = $opiquotations->quotations_by_nation($param_value); $header = '<strong>Nation</strong> &quot;'.htmlspecialchars($param_value).'&quot;&thinsp;: '.count($quots).' résultat(s).'; $search = $param_value; } else if ($param_key === 'translation') { $quots = $opiquotations->quotations_by_translation($param_value); $header = '<strong>Traduction</strong> &quot;'.htmlspecialchars($param_value).'&quot;&thinsp;: '.count($quots).' résultat(s).'; $search = $param_value; } else if ($param_key === 'all_marked') { $quots = $opiquotations->quotations_all_marked(); $header = count($quots).' citations <strong>marquées</strong>.'; } else if ($param_key === 'all') { $quots = $opiquotations->quotations_all(); $header = '<strong>Toutes</strong> les '.count($quots).' citations.'; } else { $quots = $opiquotations->quotations_by_random(10); $header = count($quots).' citations choisies <strong>aléatoirement</strong>.'; } $only_one = (count($quots) === 1); $keywords = ['citation', 'citations', 'maxime', 'maximes', 'proverbe', 'proverbes', 'littérature', 'français']; if ($only_one) { $title = 'OPiCitations n°'.$quots[0]->id().' &mdash; Dictionnaire de plus de 3000 citations'; $desc = 'OPiCitations n°'.$quots[0]->id().' :
'.htmlspecialchars($quots[0]->to_text()); $i = 0; foreach ([$quots[0]->subject(), ($quots[0]->is_maxim() ? $quots[0]->nation() : $quots[0]->author()), $quots[0]->work()] as $keyword) { if ($keyword !== null) { if ($i < 2) { $a = explode(' ', $keyword); if (count($a) > 1) { $a[] = $keyword; } } else { $a = [$keyword]; } foreach ($a as $keyword) { $keywords[] = htmlspecialchars($keyword); } unset($a); } ++$i; } unset($i); unset($keyword); } else { $title = 'OPiCitations &mdash; Dictionnaire de plus de 3000 citations'; $desc = 'Dictionnaire de plus de 3000 citations.'; if ($header !== null) { $desc .= '
'.strip_tags($header); } } $desc_open_graph = OPiQuotations\html_text_cut($desc, 300); $desc = OPiQuotations\html_text_cut($desc, 160); $url_site = 'http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).'/'; $url = $url_site; if ($only_one) { $url .= '?id='.$quots[0]->id(); } else { if ($param_key !== null) { $url .= '?'.$param_key; if ($param_value !== null) { $url .= '='.rawurlencode($param_value); } } } ?><!DOCTYPE html>
<html lang="fr">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

    <meta name="viewport" content="width=device-width, initial-scale=1">

    <meta name="author" content="Olivier Pirson">
    <meta name="description" content="<?php echo $desc; ?>">
    <meta name="keywords" content="<?php echo implode(',', $keywords); ?>">
    <meta name="keywords" lang="en" content="quotation,quotations,maxim,maxims,proverb,proverbs,literature,French">

    <title><?php echo $title; ?></title>

    <link rel="stylesheet" type="text/css" href="public/css/style.min.css">
    <style type="text/css" title="highlight">
/* Stylesheet to activate/deactivate highlight with JavaScript. */
    </style>

<?php if ($only_one): ?>
    <script type="text/javascript">window.___gcfg = {lang: 'fr', parsetags: 'explicit'};</script>
    <script type="text/javascript" src="http://platform.twitter.com/widgets.js" async="async"></script>
    <script type="text/javascript" src="http://connect.facebook.net/fr_FR/sdk.js" async="async"></script>
    <script type="text/javascript" src="https://apis.google.com/js/platform.js" async="async"></script>
<?php endif; ?>
    <script type="text/javascript" src="public/js/OPiQuotations.automatic-min.js" async="async"></script>

    <link rel="icon" type="image/x-icon" href="favicon.ico">

    <link rel="canonical" href="<?php echo $url; ?>">

    <meta property="og:image" content="<?php echo $url_site; ?>public/img/OPiQuotations<?php
 $all_is_maxim = !empty($quots) || ($param_key === 'nation'); if ($all_is_maxim) { foreach ($quots as $quot) { if (!$quot->is_maxim()) { $all_is_maxim = false; break; } } if ($all_is_maxim) { echo '-maxim'; } } unset($all_is_maxim); ?>-256x256-t.png">
    <meta property="og:description" content="<?php echo $desc_open_graph; ?>">
    <meta property="og:title" content="<?php echo $title; ?>">
    <meta property="og:type" content="website">
    <meta property="og:url" content="<?php echo $url; ?>">

    <meta name="msapplication-TileColor" content="#fdfdd0">
    <meta name="msapplication-square150x150logo" content="public/img/OPiQuotations-64x64-t.png">
  </head>
  <body>
    <div id="top"></div>
<!--[if lt IE 8]>
    <div class="outdated-IE">
      Votre navigateur est complètement <strong>obsolète</strong>.
      Je préconise
      <strong><a href="https://www.mozilla.org/" target="_blank">Firefox</a></strong>.
    </div>
<![endif]-->

    <nav id="lists">
<?php
 foreach ($LABELS as $key=>$label) { if (isset($lists[$key])) { echo '<section id="list-', $key, '" class="list" aria-haspopup="true">
  <header>
    <button onclick="lists_hide();">Fermer</button>
    <button class="float-right" onclick="lists_hide();">Fermer</button>
    <h2>', $label, 's</h2>
  </header>
  <div id="list-', $key, '-container">Chargement&hellip;</div>
</section>
'; } } unset($key); unset($label); ?>
    </nav>

    <nav id="panel">
<!--[if lt IE 9]>
      <header id="please-don-t-use-IE">
        <p>Je vous en supplie,<br>utilisez un <i>vrai</i> navigateur&nbsp;!</p>
        <p>
          Je préconise
          <strong><a href="https://www.mozilla.org/" target="_blank">Firefox</a></strong>.
        </p>
      </header>
<![endif]-->
      <form class="big-buttons" action="#">
        <button name="random_10">10 choisies <strong>aléatoirement</strong></button>
        <button name="all_marked">Toutes celles <strong>marquées</strong></button>
        <button name="all"><strong>Toutes</strong> les citations/maximes</button>
      </form>
      <ul id="menu" class="smallskip">
<?php
 foreach ($LABELS as $key=>$label) { echo '        <li class="', $key, '">
          <div>
            <label for="', $key, '">', $label, '</label>&thinsp;:
'; if (isset($lists[$key])) { echo '            <button class="float-right" onclick="list_open(\''.$key.'\'); return false;">liste</button>
'; } echo '          </div>
          <form action="#">
            <input id="', $key, '" name="', $key, '" type="text"', (isset($params[$key]) ? ' value="'.htmlspecialchars($params[$key]).'"' : null), '>
          </form>
        </li>
'; } unset($LABELS); unset($key); unset($label); ?>
        <li>
          <button onclick="highlight_on_off();" title="Néglige certaines occurences utilisant certains caractères non-alphanumériques.">Surligner</button>
          <a class="go-bottom" href="#bottom"><span>&darr;</span></a>
          <a class="go-top" href="#top"><span>&uarr;</span></a>
        </li>
      </ul>

      <footer>
        <div id="about">
          <div>
            <h2>&Agrave; propos de</h2>
            <div aria-haspopup="true">
              <h3>
                <a class="nodecoration" href="<?php echo $url_site; ?>">O<span class="surname">Pi</span>Citations</a>
              </h3>
              <p class="right">version 02.00.00 &mdash; 26 octobre 2015</p>
              <p>
                Ensemble des citations pour l&rsquo;essentiel jadis récoltées par mes soins au hasard de mes lectures
                (accumulées dans un programme créé à l&rsquo;époque en AMOS BASIC
                et déjà réutilisées par ce
                <a href="http://www.opimedia.be/DS/grenier/index.htm#enre" target="_blank">programme C</a>
                sous M$-DO$).
              </p>
              <p>
                Vous pouvez me contacter par e-mail pour me signaler toute erreur constatée&thinsp;:
                <a class="monospace" href="mailto:olivier_pirson_opi@yahoo.fr">olivier_pirson_opi@yahoo.fr</a>
              </p>
              <p class="smallskip sep">
                Accompagnent cette application&thinsp;:
              </p>
              <ul>
                <li>
                  Une version réduite n&rsquo;affichant qu&rsquo;une seule citation
                  (pouvant être utilisée en tant qu&rsquo;<span class="monospace">iframe</span>
                  pour l&rsquo;inclure dans une autre page Web)&thinsp;:
                  <strong><a class="uneOPiQuotation" href="uneOPiCitation.php" target="_blank">une OPiCitation</a></strong>
                </li>
                <li>
                  Une citation postée chaque jour sur Twitter&thinsp;:
                  <strong><a href="https://twitter.com/OPiCitationJour" target="_blank">@OPiCitationJour</a></strong>
                </li>
                <li>
                  Une autre sur Facebook&thinsp;:
                  <strong><a href="https://www.facebook.com/1OPiCitationParJour" target="_blank">1OPiCitationParJour</a></strong>
                </li>
              </ul>
              <p class="smallskip sep">
                Programme PHP/MySQL/HTML/Sass/JavaScript sous licence libre <abbr title="GNU General Public License">GPL</abbr>.
              </p>
              <ul>
                <li>
                  Sources complètes (avec le fichier de citations) sur Bitbucket&thinsp;:
                  <strong><a lang="en" class="monospace" href="https://bitbucket.org/OPiMedia/opiquotations" target="_blank">https://bitbucket.org/OPiMedia/opiquotations</a></strong>
                </li>
                <li><strong><a lang="en" href="http://www.opimedia.be/DS/webdev/PHP/OPiQuotations/docs/index.html" target="_blank">Documentation HTML en ligne</a></strong></li>
              </ul>
              <p class="smallskip sep ds-jf-opi">
                D&rsquo;autres citations sur mes sites&thinsp;:
                <a href="http://www.opimedia.be/DS/citations/index.htm" target="_blank"><img src="public/img/DS-t.png" width="80" height="34" alt="[DS]"></a>
                <a href="http://www.opimedia.be/JF/citations/index.htm" target="_blank"><img src="public/img/JF-t.png" width="41" height="34" alt="[JF]"></a>
                <a href="http://www.opimedia.be/citations/index.htm" target="_blank"><img src="public/img/OPi-t.png" width="41" height="34" alt="[OPi]"></a>
              </p>
              <p class="smallskip sep center">
                <a class="donate" href="http://www.opimedia.be/donate/index.htm" target="_blank"></a>
                <a class="opi" href="http://www.opimedia.be/" target="_blank">Olivier <span class="surname">Pirson</span> O<span class="surname">Pi</span></a>
              </p>
            </div>
          </div>
        </div>
        <div>
          <small>Une citation par jour sur <strong>Twitter</strong>&thinsp;:</small><br>
          <a class="icon-Twitter" href="https://twitter.com/OPiCitationJour" target="_blank">@OPiCitationJour</a>
        </div>
        <div class="smallskip">
          <small>Une citation par jour sur <strong>Facebook</strong>&thinsp;:</small><br>
          <a class="icon-Facebook" href="https://www.facebook.com/1OPiCitationParJour" target="_blank">1OPiCitationParJour</a>
        </div>
      </footer>
    </nav>

    <main>
      <h1>
        <a class="nodecoration" href="<?php echo $url_site; ?>"><span>O<span class="surname">Pi</span>Citations</span></a>
      </h1>

      <header><?php
 if ($header !== null) { echo $header; } echo '</header>
'; foreach ($quots as $quot) { echo $quot->to_html($search); } unset($quot); if ($only_one) { $max_length = 140 - 22 - 1; $quot_short = htmlspecialchars($quots[0]->to_text_twitter(null, null, $max_length)); echo '      <footer id="sharing-global">
        Partager cette citation&thinsp;:
        <ul>
          <li>
            <a class="twitter-share-button" href="https://twitter.com/share" data-lang="fr" data-text="', $quot_short, '" data-url="', $url, '"', (mb_strlen($quot_short) + 21 <= $max_length ? ' data-via="OPiCitationJour"' : ''), '></a>
          <li>
            <div class="fb-like" data-href="', $url, '" data-layout="button_count" data-share="true" data-show-faces="true"></div>
          <li>
            <div class="g-plus" data-action="share" data-annotation="bubble" data-href="', $url, '" data-width="120"></div>
        </ul>
      </footer>
'; } ?>
    </main>

    <nav id="right-panel">
      <a class="go-top" href="#top"><span>&uarr;</span></a>
      <a class="go-bottom" href="#bottom"><span>&darr;</span></a>
    </nav>

    <div id="bottom"></div>
  </body>
</html>
